
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

    <title>Hello, world!</title>
  </head>
  <body>
    <div class="container mt-5">
        <div class="row" style="text-align:center">
            <div class="col-md-12 text-center">
                <h1 class="text-white">Direct Print a div use javascript</h1>
            </div>
            <div class="col-md-6">
                <div id="printed_div_id" style="width: 300px; height:400px; border-radius: 10px; background-color:antiquewhite;">
                    <h1>Print Div </h1>
                </div>
            </div>
            <div class="col-md-6">
                <br />
                <button class="btn btn-warning text-white" type="button" onclick="print();">Print Now...</button>
                <p class="text-danger">
                    If you don't set a printer name in js, system use default printer for printing.
                </p>
                <hr>
                <a href="https://www.neodynamic.com/products/printing/js-print-manager/download/">
                    <h4>https://www.neodynamic.com/products/printing/js-print-manager/download/</h4>
                </a>
                <br>
                <a href="https://www.neodynamic.com/downloads/jspm/">
                    <h3 class="text-danger">You have to download this software </h3>
                </a>
                
            </div>
            
        </div>
    </div>

    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js" integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js" integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous"></script>
    -->

    <script src="js/JSPrintManager.js"></script>
    <script src="js/bluebird.min.js"></script>
    <script src="js/jquery-3.2.1.slim.min.js"></script>
    <script src="js/html2canvas.min.js"></script>
  
    <script>
      //WebSocket settings
      JSPM.JSPrintManager.auto_reconnect = true;
      JSPM.JSPrintManager.start();
      JSPM.JSPrintManager.WS.onStatusChanged = function () {
          if (jspmWSStatus()) {
              //get client installed printers
              JSPM.JSPrintManager.getPrinters().then(function (myPrinters) {
                    for (var i = 0; i < myPrinters.length; i++) {
                        console.log(myPrinters[i]);
                    } 
                });
            }
        };
    
      //Check JSPM WebSocket status
      function jspmWSStatus() {
          if (JSPM.JSPrintManager.websocket_status == JSPM.WSStatus.Open)
              return true;
          else if (JSPM.JSPrintManager.websocket_status == JSPM.WSStatus.Closed) {
              alert('JSPrintManager (JSPM) is not installed or not running! Download JSPM Client App from https://neodynamic.com/downloads/jspm');
              return false;
          }
          else if (JSPM.JSPrintManager.websocket_status == JSPM.WSStatus.Blocked) {
              alert('JSPM has blocked this website!');
              return false;
          }
      }
    
      //Do printing...
      function print(o) {
          var printer_name ="";
          if (jspmWSStatus()) {
              //generate an image of HTML content through html2canvas utility
              html2canvas(document.getElementById('printed_div_id'), { scale: 5 }).then(function (canvas) {
                  //Create a ClientPrintJob
                  var cpj = new JSPM.ClientPrintJob();
                  //Set Printer type (Refer to the help, there many of them!)
                  if (printer_name) {
                    cpj.clientPrinter = new JSPM.InstalledPrinter(printer_name);
                  } else {
                    cpj.clientPrinter = new JSPM.DefaultPrinter();
                  }
                  //Set content to print... 
                  var b64Prefix = "data:image/png;base64,";
                  var imgBase64DataUri = canvas.toDataURL("image/png");
                  var imgBase64Content = imgBase64DataUri.substring(b64Prefix.length, imgBase64DataUri.length);
    
                  var myImageFile = new JSPM.PrintFile(imgBase64Content, JSPM.FileSourceType.Base64, 'myFileToPrint.png', 1);
                  //add file to print job
                  cpj.files.push(myImageFile);
    
                  //Send print job to printer!
                  cpj.sendToClient();
              });
          }
      }
    </script>
  </body>
</html>
                            
  
  
  
  

  